;Program BOOTSEC.ASM: Display contents of disk A's boot sector (with ASCII).
;

PILHA           SEGMENT PARA STACK 'STACK'

                DW  100 DUP(?)

                TOP_PILHA LABEL WORD
PILHA           ENDS


DADOS           SEGMENT PARA 'DATA'

BMSG    DB    'Boot sector for diskette in drive A:',0DH,0AH,0DH,0AH,'$'
EMSG1   DB    'Error! Can not reset diskette system.',0DH,0AH,'$'
EMSG2   DB    'Error! Can not read boot sector.',0DH,0AH,'$'

ERRO1   DB    'Funcao invalida $'
ERRO2   DB    'Address mark nao encontrado $'
ERRO3   DB    'Tentativa de escrita em disco protegido $'
ERRO4   DB    'Setor nao encontrado $'
ERRO8   DB    'Falha no controlador de DMA $'
ERRO9   DB    'Buffer estourou fronteira $'
ERR10   DB    'Setor com erro $'
ERR20   DB    'Falha no controlador de disco $'
ERR40   DB    'Trilha nao encontrada $'
ERR80   DB    'Timeout $'
FUDEU   DB    'Fudeu! $'
BLANK   DB    ' $'
PRESS   DB    0DH,0AH,'Press any key for next 256 bytes...'
CRLF    DB    0DH,0AH,'$'
DBUF    DB    1024 DUP(0)

DADOS ENDS

CODIGO          SEGMENT PARA 'CODE'
                ASSUME CS:CODIGO,SS:PILHA,DS:DADOS,ES:DADOS

INICIO          PROC   FAR

                MOV    AX,DADOS
                MOV    DS,AX
		MOV    ES,AX             ;INICIALIZA REGISTROS DE SEGMENTO.

        MOV   AX,DS
        MOV   ES,AX       ;set up extra segment
        MOV   AH,0        ;reset disk function
        MOV   DL,0        ;drive A
        INT   13H         ;BIOS call
        JNC   OK
        CALL  VerificaErro
        
        LEA   DX,EMSG1    ;set up pointer to error message
PRE:    MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        JMP   EXIT
OK:     CALL  READ        ;read boot sector, first try
        JNC   OBM
        CALL  READ        ;read boot sector, second try
        JNC   OBM
        CALL  READ        ;read boot sector, last try
        JNC   OBM
        LEA   DX,EMSG2    ;set up pointer to error message
        JMP   PRE         ;go process error
OBM:    LEA   DX,BMSG     ;set up pointer to boot message
        MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        SUB   SI,SI       ;clear index pointer
        CALL  SHOWDTA     ;show first half of DTA
        LEA   DX,PRESS    ;set up pointer to press message
        MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        MOV   AH,1        ;read keyboard function
        INT   21H         ;DOS call
        LEA   DX,CRLF     ;set up pointer to crlf string
        MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        CALL  SHOWDTA     ;show second half of DTA

EXIT:   MOV AH,4CH
        INT 21H

VerificaErro PROC NEAR
        CMP  AH, 01H
        JE   errao1
        CMP  AH, 02H
        JE   errao2
        CMP  AH, 03H
        JE   errao3
        CMP  AH, 04H
        JE   errao4
        CMP  AH, 08H
        JE   errao8
        CMP  AH, 09H
        JE   errao9
        CMP  AH, 10H
        JE   erro10
        CMP  AH, 20H
        JE   erro20
        CMP  AH, 40H
        JE   erro40
        CMP  AH, 80H
        JE   erro80
        LEA  DX, FUDEU
        JMP PRE

VerificaErro ENDP

errao1:
      LEA DX, ERRO1
      JMP PRE

errao2:
      LEA DX, ERRO2
      JMP PRE

errao3:
      LEA DX, ERRO3
      JMP PRE

errao4:
      LEA DX, ERRO4
      JMP PRE

errao8:
      LEA DX, ERRO8
      JMP PRE

errao9:
      LEA DX, ERRO9
      JMP PRE

erro10:
      LEA DX, ERR10
      JMP PRE

erro20:
      LEA DX, ERR20
      JMP PRE

erro40:
      LEA DX, ERR40
      JMP PRE

erro80:
      LEA DX, ERR80
      JMP PRE


READ    PROC  NEAR
        LEA   BX,DBUF     ;set of pointer to DTA
        MOV   AH,2        ;read disk sectors function
        MOV   AL,2        ;read one sector
        MOV   DL,0        ;from drive A
        MOV   DH,0        ;head 0
        MOV   CX,1        ;sector 1
        INT   13H         ;BIOS call
        RET
READ    ENDP

SHOWDTA PROC  NEAR
        MOV   CX,16       ;load line counter
NLYN:   PUSH  CX          ;save line counter
        MOV   AX,SI       ;load pointer address
        CALL  DISPHEX2    ;output hex address
        MOV   DL,':'      ;load colon
        MOV   AH,2        ;display character function
        INT   21H         ;DOS call
        MOV   CX,16       ;load byte counter
NBYT:   LEA   DX,BLANK    ;set up pointer to blank string
        MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        MOV   AL,ES:DBUF[SI] ;get next byte
        CALL  DISPHEX     ;output it
        INC   SI          ;advance pointer
        LOOP  NBYT        ;repeat for next byte
        CALL  SHOWASC     ;output ASCII equivalents
        LEA   DX,CRLF     ;set up pointer to crlf string
        MOV   AH,9        ;display string function
        INT   21H         ;DOS call
        POP   CX          ;get line counter back
        LOOP  NLYN        ;and repeat until done
        RET
SHOWDTA ENDP

SHOWASC  PROC  NEAR
         LEA   DX,BLANK    ;set up pointer to blank string
         MOV   AH,9        ;display string function
         INT   21H         ;DOS call
         LEA   DX,BLANK    ;set up pointer to blank string
         MOV   AH,9        ;display string function
         INT   21H         ;DOS call
         SUB   SI,16       ;adjust pointer
         PUSH  CX          ;save current counter
         MOV   CX,16       ;load character counter
GCHR:    MOV   DL,ES:DBUF[SI]  ;get next byte
         INC   SI          ;advance pointer
         AND   DL,7FH      ;convert to 7-bit ASCII
         CMP   DL,20H      ;is it printable?
         JC    BLNK        ;no, go output a blank
         CMP   AL,80H      ;is it still printable?
         JNC   BLNK
AOUT:    MOV   AH,2        ;display character function
         INT   21H         ;DOS call
         LOOP  GCHR        ;repeat until done
         POP   CX          ;get counter back
         RET
BLNK:    MOV   DL,20H      ;load blank character
         JMP   AOUT
SHOWASC  ENDP


DISPHEX PROC NEAR
        PUSH AX           ;save number
        SHR  AL,1         ;shift upper nybble down
        SHR  AL,1
        SHR  AL,1
        SHR  AL,1
        CMP  AL,10        ;is nybble value less than 10?
        JC   NHA1         ;yes, go convert and display
        ADD  AL,7         ;add alpha bias
NHA1:   ADD  AL,30H       ;add ASCII bias
        MOV  DL,AL        ;load character
        MOV  AH,2         ;display character function
        INT  21H          ;DOS call
        POP  AX           ;get number back
        AND  AL,0FH       ;work with lower nybble
        CMP  AL,10        ;is it less than 10?
        JC   NHA2         ;yes, go convert and display
        ADD  AL,7         ;add alpha bias
NHA2:   ADD  AL,30H       ;add ASCII bias
        MOV  DL,AL        ;load character
        MOV  AH,2         ;display character function
        INT  21H          ;DOS call
        RET
DISPHEX ENDP

DISPHEX2 PROC  NEAR
         PUSH  AX         ;save number
         XCHG  AH,AL      ;get upper byte
         CALL  DISPHEX    ;output it
         POP   AX         ;get number back
         CALL  DISPHEX    ;output lower byte
         RET
DISPHEX2 ENDP

CODIGO ENDS

         END INICIO

