#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#define LIMIT 10000

int shared = 0;        /* variavel compartilhada pelas threads */
sem_t my_sem;

void prog1 (int * k) { /* prog1 sera' uma das threads */
  int j,m,tmp;
  for (j=1;j<=*k;j++) {
    sem_wait(&my_sem);
    tmp = shared;
    tmp = tmp + 1;
    for (m=0;m<=LIMIT;m++) {}; /* apenas para demorar um pouco */
    if (j % 1 == 0) { 
      printf(".%d.",tmp);
    };
    shared = tmp;
    sem_post(&my_sem);
    for (m=0;m<=LIMIT;m++) {}; /* apenas para demorar um pouco */
  }
  printf(".-> %d\n",shared);
}

void prog2 (int * k) {
  int j,m,tmp;
  for (j=1;j<=*k;j++) {
    sem_wait(&my_sem);
    tmp = shared;
    tmp = tmp + 1;
    for (m=0;m<=LIMIT;m++) {}; /* apenas para demorar um pouco */
    if (j % 1 == 0) { 
      printf("*%d*",tmp);
    };
    shared = tmp;
    sem_post(&my_sem);
    for (m=0;m<=LIMIT;m++) {}; /* apenas para demorar um pouco */
  }
  printf("*-> %d\n",shared);
}

int main (void) {
  pthread_t thread1, thread2;
  pthread_attr_t attr;
  int a;
  sem_init(&my_sem,0,1);
  pthread_attr_init(&attr); /* initialize attr with default attributes */
  pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);  /* system-wide 
                                                          contention */
  a = 100;
  /* cria as duas threads */
  if (pthread_create(&thread1, &attr, (void *) prog1, (void *) &a) != 0)
     printf("Erro na criacao da thread1!");
  if (pthread_create(&thread2, &attr, (void *) prog2, (void *) &a) != 0)
     printf("Erro na criacao da thread2!");
  /* espera as threads terminarem */
  pthread_join(thread1, NULL);
  pthread_join(thread2, NULL);
  printf("--> %d\n",shared);
}
