/* Incluso das bibliotecas padro */
#include <stdio.h>
#include <stdlib.h>

/* Incluso das bibliotecas padro */
#include <semaphore.h>
#include <pthread.h>

/* Definio das constantes */
#define TIMETOEAT 3
#define DELAY 10000000

/* Semforos: os garfos sero semforos */
sem_t forks[5];


/* Inicializao dos semforos */
void init_forks()
{	
	int n;

	for(n=0; n<5; n++)
		sem_init(&forks[n], 0, 1); 
		
}

/* Funo executada pelos processos dos filsofos de 1 a 4 */
void dining(int n)
{
	int i, j;

	for (i=0; i<2; i++)
	{
		 sem_wait(&forks[n]);
		 printf("Filosofo %d pegou garfo esquerda (garfo %d).\n",n,n);
		 sem_wait(&forks[(n+1)%5]);
		 printf("Filosofo %d pegou garfo direita (garfo %d).\n",n,(n+1)%5);
		 printf("Filosofo %d comendo.\n",n);
	 
		 for(j=0; j<DELAY; j++);
	 
		 sem_post(&forks[n]);
		 sem_post(&forks[(n+1)%5]);
		 printf("Filosofo %d parou de comer.\n",n);
		 printf("Filosofo %d liberou os garfos (garfos %d e %d).\n",n,n,(n+1)%5);
		 printf("Filosofo %d pensando.\n",n);
	}
}


int main()
{
	int i;

	pthread_t filosofos[5];
	pthread_attr_t attr;
	
	pthread_attr_init(&attr);
	
	init_forks();
	for(i=0;i<5;i++)
		pthread_create(&filosofos[i], &attr, (void *)&dining, (int *) i);
		 
	for(i=0;i<5;i++)
		pthread_join(filosofos[i], NULL);
  	
  	return 0;
}
