;===============================================================
; Projeto de Interface Hardware-Software - Semaforo Inteligente
;
; Tem como objetivo o controle de um semaforo, registrando o fluxo de uma via e 
; eventuais infracoes cometidas e tambem visa otimizar o trafego no local.
;
; Professor: Paulo Maciel
; Integrantes: Diego Martins (dmvb), Diogo Maciel (dmg), Evilasio Vilar (evs), Saulo Lopes (slso)
;===============================================================

.model small
.286
.stack 100h

.data


	SETA_ESQ   	equ 	4B00h
     	SETA_DIR   	equ 	4D00h
     	SETA_ACIMA  	equ 	4800h
     	SETA_ABAIXO 	equ 	5000h
        ESCAPE        	equ 	011bh
	SPACE	    	equ	3920h
	ENTER_KEY  	equ 	1c0dh
	
	
	; portas
	PORTA_ESCRITA 	dw	378h
	PORTA_LEITURA	dw	379h
	
	; graficos da interface
	sem1      DB  13,10,13,10,13,10,'                                   ',13,10,'$'
	sem2	  DB  '                                   ',13,10,'$'
	sem3	  DB  '              Via Norte-Sul        ',13,10,'$'
	sem4	  DB  '                                  ',13,10,'$'
	sem5	  DB  '                         v                   <---',13,10,'$'
	sem6	  DB  '                                        Via Leste-Oeste',13,10,'$'
	sem7	  DB  '          F   ',13,10,'$'
	sem8      DB  13,10,'                                TT  A',13,10,'$'
	sem9	  DB  '              ',13,10,'$'	
	
        ; strings da tela inicial
	mensagemInicial db 	'Projeto de Interface Hardware-Software - Semaforo Inteligente',13,10,'$'
	descricao 	db 	13,10,'Tem como objetivo o controle de um semaforo, registrando o fluxo de uma via e eventuais infracoes cometidas e tambem visa otimizar o trafego no local',13,10,'$'
	integrantes 	db 	13,10,'Professor: Paulo Maciel',13,10,'Integrantes: Diego Martins, Diogo Maciel, Evilasio Vilar, Saulo Lopes',13,10,'$'
	opcoes 		db 	13,10,'Menu:',13,10,'',13,10,'1: Iniciar Simulacao',13,10,'2: Configuracoes',13,10,'3: Sair',13,10,'$'
	select 		db 	13,10,'Selecione sua opcao (1, 2 ou 3)',13,10,'$'
	opcaoInvalida 	db 	13,10,'Foi digitada uma opcao invalida',13,10,'$'
	linha		db	13,10,'------------------------',13,10,'$'
        
        ; strings da tela de sinal
        
        telaSinal 	db 	13,10,'Sinal iniciado...',13,10,'$'
        
        ; strings da tela de configuracoes
    
        telaConfiguracoes 	db 	13,10,'Configuracoes',13,10,'',13,10,'1: Modificar Data e Hora',13,10,'2: Selecionar Porta Paralela',13,10,'3: Voltar',13,10,'$'
        
        ; strings da tela modificar data e hora
        
        ; strings da tela selecionar porta paralela
        
        telaPorta	db	13,10,'Selecionar Porta Paralela',13,10,'',13,10,'1: LPT1',13,10,'2: LPT2',13,10,'3: LPT3',13,10,'4: LPT4',13,10,'$'
        
        tempoRestante	db	13,10,'Tempo Restante: $'
        stringVazia	db	'   $'
        mudancaNivel	db	'Politica de escalonamento nivel $'
        
        mensagemLOAberto	db	'Semaforo LO Aberto$'
        mensagemNSAberto	db	'Semaforo NS Aberto$'
        
        ; posicoes do cursor da tela
        posicaoCursorNivelX	db	32
        posicaoCursorNivelY	db	1
        
        posicaoCursorTempoX	db	32	; a posicao x do cursor para o numero de segundos restantes
        posicaoCursorTempoY	db	14	; a posicao y do cursor para o numero de segundos restantes
        
        posicaoCursorSinalLOX	db	36
        posicaoCursorSinalLOY	db	14
        
        posicaoCursorSinalNSX	db	32
        posicaoCursorSinalNSY	db	12
        
        posicaoCursorFluxoLOX	db	50
        posicaoCursorFluxoLOY	db	14
        
        posicaoCursorFluxoNSX	db	32
        posicaoCursorFluxoNSY	db	20    
        
        
        LuzesProtoboard		db	0	; luzes da protoboard
        estadoAnterior		db	0	; como estavam as entradas no estado anterior
        SinalLOFechado		DB	?	; indica se o semafro Leste-Oeste est fechado (estado do sistema)
	NivelEscalonamento	DB	?	; indica o nivel de escalonamento atual, de acordo com o fluxo de veiculos
	
	tempoSinalLO	DB	?	; tempo em que o sinal LO ficar aberto
	tempoSinalNS	DB	?	; tempo em que o sinal NS ficara aberto
	
	fluxoLO		db	0	; numero de veiculos que esto passando ou passaram pelo sinal LO
	fluxoNS		db	0	;                        //                         pelo sinal NS

.code

limpaBuffer PROC                     			; macro que limpa o buffer do teclado(evitando erros depois de delays)
  	push ax dx																;salva os registradores usados
  	mov dl, 0																	;
  	mov ah, 0Ch																; seta os parametros da interrupo a ser chamada 
  	mov al, 06h																; 
  	int 21h																		; chama a interrupo do DOS que limpa o buffer
  	pop ax dx																	; recupera os registradores
ENDP limpaBuffer

; rotina auxiliar para impressao de numeros inteiros
Puti2   proc
    	push  bx																;
    	push  cx																; salva registradores na pilha
    	push  dx																;
    	mov bx, 10															; move o valor 10 (sistema decimal) para o registrador BX
    	xor cx, cx															; apaga o valor de CX
Puti2Lp:
	xor dx, dx															; apaga o valor de DX
    	div bx																	; divide AX por BX
    	or  dl, '0'															; faz um OU com o caracter 0 (zero)
    	push  dx																; salva DX
    	inc cx																	; incrementa o valor de CX
    	or  ax, ax															
    	jnz Puti2Lp															; continua no lao se for diferente de zero
Popi2lp:
	pop ax																	; recupera AX
    	call  putcstdout												; chama o procedimento que imprime um caracter na tela
    	loop  Popi2lp														; efetua o loop CX vezes
    	pop dx																	;
    	pop cx																	; recupera registradores
    	pop bx																	;
    ret
PutI2   endp

; @param ax
PutU_   proc  far														; procedimento auxiliar que salva o valor de ax e chama proc para converter
    	push  ax																; um nmero para caracter
    	call  PutI2															; chama proc que converte e imprime na tela
    	pop ax																	; recupera ax
    	ret
PutU_   endp


; @param  ax
putcstdout  proc														; imprime um caractere na tela
    	push  ax																;
    	push  dx																; salva registradores na pilha
    	mov dl, al															; move o valor de AL para DL
    	mov ah, 2																; seta o tipo da interrupo a ser chamada
    	int 21h																	; chama interrupo que imprime caracter na tela
    	pop dx																	;
    	pop ax																	; recupera registradores
    	ret
putcstdout  endp

moveCursor  Macro pX, pY              			; move o cursor do teclado para a posio (pX,pY)       
	pusha																			; salva registradores
	mov ah, 2h																;
	mov bh, 0h																; seta o tipo da interrupo a ser chamada
	mov dl, pX																;
 	mov dh, pY																; posio do cursor  guardada em DX
  	int 10h 																	; interrupo do DOS que muda a posio do cursor na tela
  	popa																			; recupera registradores
ENDM moveCursor

imprimeString Macro stringIN          			; imprime uma string na tela
  	pusha																			
  	mov dx, OFFSET stringIN
  	mov ah, 9
  	int 21h
  	popa
ENDM imprimeString

; ================
; Modifica o estado atual do sistema,
; Isto , se o sinal LO estiver fechado, ele ser aberto
ChangeState	PROC
	pusha
	mov	al, luzesProtoboard
	cmp	SinalLOFechado, 1 	; se LO estiver fechado,
	mov	dx, PORTA_ESCRITA	; endereco de escrita
	je	abreLO			; abre LO
	
	abreNS:
	mov	SinalLOFechado, 1	; seta a variavel
	or	al, 00000001b		; acende a primeira luz
	and	al, 11111101b		; apaga a segunda luz
	jmp	fim
	
	abreLO:
	mov	SinalLOFechado, 0	; seta a variavel
	or	al, 00000010b		; acende a segunda luz
	and	al, 11111110b		; apaga a primeira luz
	
	fim:
	mov	luzesProtoboard, al
	out	dx, al
	popa
	ret
ChangeState	ENDP

; ================
; Imprime mapa.
ImprimeMapa	PROC
	pusha
	imprimeString	sem1
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem3
	imprimeString	sem2
	imprimeString	sem4
	imprimeString	sem5
	imprimeString	sem6
	imprimeString	sem7
	imprimeString	sem8
	imprimeString	sem9
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	imprimeString	sem2
	popa
	ret
ImprimeMapa	ENDP

;==============
; Procedimento que gera 1 segundo de delay, checando as entradas 
; da protoboard e incrementando as variaveis e incrementando quando necessario.
; CX <- High clock word
; DX <- Low clock word
; For a second you need to count ~ 18 ticks	
Delay1Seg	PROC
	pusha
  	mov 	di, 18
  	mov 	ah, 0
  	int 	1ah
  	mov 	bx, dx
	  
	delay:
	call	VerificaEntradas
  	mov 	ah, 0
  	int 	1ah
  	sub 	dx, bx
  	cmp 	di, dx
  	ja 	delay
  	popa
  	ret
Delay1Seg	ENDP

;=============
; Imprime o fluxo de veiculos da via LO
ImprimeFluxoLO		PROC
	pusha
	moveCursor	posicaoCursorFluxoLOX, posicaoCursorFluxoLOY
	imprimeString	stringVazia
	moveCursor	posicaoCursorFluxoLOX, posicaoCursorFluxoLOY
	mov	ah, 0
	mov	al, fluxoLO
	call	putu_
	popa
	ret
ImprimeFluxoLO		ENDP	

;=============
; Imprime o fluxo de veiculos da via NS
ImprimeFluxoNS		PROC
	pusha
	moveCursor	posicaoCursorFluxoNSX, posicaoCursorFluxoNSY
	imprimeString	stringVazia
	moveCursor	posicaoCursorFluxoNSX, posicaoCursorFluxoNSY
	mov	ah, 0
	mov	al, fluxoNS
	call	putu_
	popa
	ret
ImprimeFluxoNS		ENDP	


;=============
; Verifica as entradas da protoboard. E de acordo com o estado atual, 
; pode registrar o fluxo de veiculos bem como identificar quando um veiculo
; avanca um sinal fechado.
VerificaEntradas	PROC
	pusha
	cmp	estadoAnterior, 0	; se o estado anterior for diferente de 0,
	jne	verificou		; nao ha necessidade de verificar as entradas.
	mov	dx, PORTA_LEITURA
	in	al, dx
	shr	al, 4			; retira os 4 bits menos significativos
	mov	estadoAnterior, al	; atualiza o estado anterior
	cmp	al, 1			; carro passou pela Via LO
	je	viaLO
	cmp	al, 3			; carro passou pela Via NS
	je	viaNS
	
	jmp	verificou		; se nenhum carro passou, finaliza a verificacao
	viaLO:
		cmp	SinalLOFechado, 1	; se o sinal LO estiver fechado
		je	viaLOMulta		; veiculo ultrapassou sinal
		inc	fluxoLO			; senao, e' incrementado o fluxo
		call	ImprimeFluxoLO
		jmp	verificou
		viaLOMulta:
			mov	al, luzesProtoboard
			or	al, 00000100b		; acende indicador de multa
			mov	dx, PORTA_ESCRITA
			out	dx, al
			jmp	verificou
			
	viaNS:
		cmp	SinalLOFechado, 0	; se o sinal LO estiver aberto (NS fechado)...
		je	viaNSMulta		; veiculo ultrapassou sinal
		inc	fluxoNS			; senao, e' incrementado o fluxo
		call	ImprimeFluxoLO
		viaNSMulta:
			mov	al, luzesProtoboard
			or	al, 00000100b		; acende indicador de multa
			mov	dx, PORTA_ESCRITA
			out	dx, al
	verificou:	
	popa
	ret
VerificaEntradas	ENDP

;==============
; Baseado nas variaveis FluxoLO e FluxoHS, que representam o fluxo de veiculos
; nos dois sentidos, calcula o nivel de escalonamento ideal.
;
; O nvel de escalonamento  determinado por um simples algoritmo:
; razao = ultimoFluxo(Via X) / ultimoFluxo(Via Y);
; Se razo > 2 ento
;     Configurao 1 ou 5;
; Seno se razo > 1.5 ento
;     Configurao 2 ou 4;
; Seno
;     Configurao 3;
CalculaNivelEscalonamento	PROC
	pusha
	cmp	FluxoNS, 0	; se nao houver fluxo no sentido norte-sul, 
	je	termino		; impossivel calcular. (divisao por 0)
	mov	ah, 0
	mov	al, FluxoLO	; FluxoLO e' o dividendo
	mov	bl, 6		;
	mul	bl		; al = al * 60
	mov	bl, FluxoNS	; FluxoNS e' o divisor
	div	bl
	cmp	al, 12		; 2 * 6 = 12
	jae	nivel1
	cmp	al, 9		; 1.5 * 6 = 9
	jae	nivel2
	cmp	al, 3		; 0.5 * 6 = 3
	jb	nivel5
	cmp	al, 4		; 0.666 * 6 = 4
	jb	nivel4
	nivel3:
		mov	NivelEscalonamento, 3
		jmp	termino
	nivel1:
		mov	NivelEscalonamento, 1
		jmp	termino
	nivel2:
		mov	NivelEscalonamento, 2
		jmp	termino
	nivel4:
		mov	NivelEscalonamento, 4
		jmp	termino
	nivel5:
		mov	NivelEscalonamento, 5
	termino:
		moveCursor	posicaoCursorNivelX, posicaoCursorNivelY
		mov	ah, 0
		mov	al, NivelEscalonamento
		call	putu_
	popa
	ret
CalculaNivelEscalonamento	ENDP


;===============
; Rotina principal da simulacao do semaforo
Principal	PROC
	mov	dx, PORTA_ESCRITA
	mov	al, 00000010b		; abre LO e fecha(acende) NS
	out	dx, al
	mov	NivelEscalonamento, 3
	mov	SinalLOFechado, 0
	mov	tempoSinalLO, 30	; cx = tempo de abertura do sinal LO
	mov	tempoSinalNS, 30	; dx = tempo de abertura do sinal NS
	imprimeString	mudancaNivel
	call	ImprimeMapa
  	
proximo:
	call	ChangeState
	call	calculaNivelEscalonamento
	cmp	NivelEscalonamento, 1
	je	_nivel1
	cmp	NivelEscalonamento, 2
	je	_nivel2
	cmp	NivelEscalonamento, 3
	je	_nivel3
	cmp	NivelEscalonamento, 4
	je	_nivel4
	_nivel5:
		mov	tempoSinalLO, 20
		mov	tempoSinalNS, 40
		jmp	_termino
	_nivel1:
		mov	tempoSinalLO, 40
		mov	tempoSinalNS, 20
		jmp	_termino
	_nivel2:
		mov	tempoSinalLO, 35
		mov	tempoSinalNS, 25
		jmp	_termino
	_nivel3:
		mov	tempoSinalLO, 30
		mov	tempoSinalNS, 30
		jmp	_termino
	_nivel4:
		mov	tempoSinalLO, 25
		mov	tempoSinalNS, 35
	_termino:	
	cmp	SinalLOFechado, 1
	je	loopNS
	
	
loopLO:
	moveCursor	posicaoCursorSinalLOX, posicaoCursorSinalLOY
	mov	dl, 'A'
	mov	ah, 2		; imprime caractere
	int	21h		;
	moveCursor	posicaoCursorSinalNSX, posicaoCursorSinalNSY
	mov	dl, 'F'
	mov	ah, 2		; imprime caractere
	int	21h		;
	moveCursor	posicaoCursorTempoX, posicaoCursorTempoY
	mov 	dx, OFFSET stringVazia
  	mov 	ah, 9			; imprime '                          '
  	int 	21h			;
	moveCursor	posicaoCursorTempoX, posicaoCursorTempoY
	mov	ah, 0
  	mov	al, tempoSinalLO	; Imprime o inteiro com o tempo restante
  	call 	putu_			;
  	mov	ah, 1			; Recebe tecla do buffer
  	int	16h			;
  	cmp	al, 'q'			; Tecla de Saida do Programa
  	je	_terminoprinc		;
  	call	Delay1Seg
  	dec	tempoSinalLO
  	cmp	tempoSinalLO, 0		; se o tempo do sinal LO se esgotou,
  	je	_proximo			; volta ao inicio do loop
  	jmp 	loopLO
  	
_terminoprinc:
	jmp	terminoprinc
  	
_proximo:
	jmp	proximo
  	
loopNS:
	moveCursor	posicaoCursorSinalLOX, posicaoCursorSinalLOY
	mov	dl, 'F'
	mov	ah, 2		; imprime caractere
	int	21h		;
	moveCursor	posicaoCursorSinalNSX, posicaoCursorSinalNSY
	mov	dl, 'A'
	mov	ah, 2		; imprime caractere
	int	21h		;	
	moveCursor	posicaoCursorTempoX, posicaoCursorTempoY
	mov 	dx, OFFSET stringVazia
  	mov 	ah, 9			; imprime '                          '
  	int 	21h			;
	moveCursor	posicaoCursorTempoX, posicaoCursorTempoY
	mov	ah, 0
  	mov	al, tempoSinalLO	; Imprime o inteiro com o tempo restante
  	call 	putu_			;
  	mov	ah, 1			; Recebe tecla do buffer
  	int	16h			;
  	cmp	al, 'q'			; Tecla de Saida do Programa
  	je	terminoprinc		;
  	call	Delay1Seg
  	dec	tempoSinalLO
  	cmp	tempoSinalLO, 0		; se o tempo do sinal LO se esgotou,
  	je	_proximo			; volta ao inicio do loop
  	jmp 	loopNS
	terminoprinc:
	call	limpaBuffer
	moveCursor	0, 24
  	
Principal	ENDP

start:
	mov 	ax, @data
  	mov 	ds, ax
  	mov 	dx, OFFSET mensagemInicial
  	mov 	ah, 9                            
  	int 	21h
  	mov 	dx, OFFSET descricao
  	mov 	ah, 9
  	int 	21h                                ; mostra a tela inicial do programa
  	mov 	dx, OFFSET integrantes
  	mov 	ah, 9
  	int 	21h
  	telaOpcoes:
  	mov 	dx, OFFSET opcoes
  	mov 	ah, 9
  	int 	21h
  	
Escolha: 
  	mov 	dx, OFFSET select
  	mov 	ah, 9
  	int 	21h

  	mov 	ah, 7                   ; pega a escolha do menu
  	int 	21h                    

  	cmp 	al, '1'                ; opcao 1  
  	je  	IniciarSinal  

  	cmp 	al, '2'                ; opcao 2  
  	je  	OpcoesSinal  

  	cmp 	al, '3'                ;opcao 3
  	je 	Sair

  	mov 	dx, OFFSET opcaoInvalida
  	mov 	ah,9                     ; nenhuma opcao valida foi digitada
  	int 	21h
  	jmp 	Escolha

IniciarSinal:
  	mov 	dx, OFFSET telaSinal
  	mov 	ah, 9                     ; tela de iniciar sinal
  	int 	21h
	call	Principal
	
Sair:
  	mov 	ah, 4ch
  	mov 	al, 0
  	int 	21h	
  
OpcoesSinal:   
  	mov 	dx, OFFSET telaConfiguracoes
  	mov 	ah, 9                     ; tela de configuracoes
  	int 	21h
  	mov 	ah, 7
  	int 	21h
  	
  	cmp 	al, '1'                ; opcao 1  
  	je  	OpcoesHora

  	cmp 	al, '2'                ; opcao 2  
  	je  	OpcoesPorta

  	cmp 	al, '3'                ;opcao 3
  	je 	OpcoesVoltar
  	
	mov 	dx, OFFSET opcaoInvalida
  	mov 	ah,9                     ; nenhuma opcao valida foi digitada
  	int 	21h
  	jmp 	OpcoesSinal
  	
OpcoesHora:

OpcoesPorta:
	imprimeString	telaPorta

  	mov 	ah, 7
  	int 	21h  
  	cmp 	al, '1'                ; opcao 1  
  	je  	LPT1
  	cmp 	al, '2'                ; opcao 2  
  	je  	LPT2
  	cmp 	al, '3'                ; opcao 3
  	je 	LPT3
  	cmp 	al, '4'                ; opcao 4
  	je 	LPT4
	mov 	dx, OFFSET opcaoInvalida
  	mov 	ah,9                     ; nenhuma opcao valida foi digitada
  	int 	21h
  	jmp	OpcoesVoltar  	
  	LPT1:
  		mov	PORTA_ESCRITA, 378h
  		mov	PORTA_LEITURA, 379h
  		jmp	terminoLPT
  	LPT2:
  		mov	PORTA_ESCRITA, 278h
  		mov	PORTA_LEITURA, 279h
  		jmp	terminoLPT
  	LPT3:
  		mov	PORTA_ESCRITA, 3BCh
  		mov	PORTA_LEITURA, 3BDh
  		jmp	terminoLPT
  	LPT4:
  		mov	PORTA_ESCRITA, 2BCh
  		mov	PORTA_LEITURA, 2BDh
  		jmp	terminoLPT
  		
  	terminoLPT:
  		jmp	telaOpcoes
  		
OpcoesVoltar:
	jmp	telaOpcoes
END start