/**
 *  Title: Controlador de Microondas
 *  Description: Projeto da disciplina Interface Hardware Software
 *  Copyright: Copyright (c) 2004. All rigths reserved to CIn - UFPE
 * Company: CIn - UFPE</p>
 * @author VBA
 * @version 2.0
 */

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import remote.*;
import util.*;

public class MicroondasClient {

    public static void main(String[] args) {
		Console c = new Console();
		if (args[0]==null) {
            System.out.println("");
            System.out.println("");
            System.out.println("Sintaxe: java MicroondasClient <server host>");
            return;
        }
        try {
            MicroondasRemoto m = (MicroondasRemoto)
                           Naming.lookup(
                 "rmi://"+args[0]+":1099/MicroondasService");
            System.out.println("");
            System.out.println("");
            System.out.println("Controlador Remoto de Microondas - by VBA, SLSO, DMG, DMVB");
            System.out.println("");
            System.out.println("");
            System.out.println("Menu: ");
            System.out.println("");
            System.out.println("1. Incrementar 10 segundos");
            System.out.println("2. Incrementar 1 minuto");
			System.out.println("3. Cancelar");
			System.out.println("4. Ligar");
			System.out.println("5. Sair");
            System.out.println("");
			System.out.print("Opcao: ");
			int op = 0;
			boolean loop = true;
			while(loop) {
			  op = c.readInt();
              switch(op) {
    		     case 1: {
                   m.incSeg();
                   break;
                 }
    		     case 2: {
                   m.incMin();
                   break;
                 }
      		     case 3: {
                   m.cancel();
                   break;
                 }
    	  	     case 4: {
                   m.runTime();
                   break;
                 }
    	  	     case 5: {
                   loop=false;
                   break;
                 }

                 default: break;
              }
            }
        }
        catch (NotBoundException nbe) {
            System.out.println();
            System.out.println(
                       "NotBoundException");
            System.out.println(nbe);
        }
        catch (MalformedURLException murle) {
            System.out.println();
            System.out.println(
              "MalformedURLException");
            System.out.println(murle);
        }
        catch (RemoteException re) {
            System.out.println();
            System.out.println(
                        "RemoteException");
            System.out.println(re);
        }
    }
}

