/**
 *  Title: Controlador de Microondas
 *  Description: Projeto da disciplina Interface Hardware Software
 *  Copyright: Copyright (c) 2004. All rigths reserved to CIn - UFPE
 * Company: CIn - UFPE</p>
 * @author VBA
 * @version 2.0
 */

#include <jni.h>
#include "remote_Fachada.h"
#include <stdio.h>
#include <windows.h>

JNIEXPORT void JNICALL
Java_remote_Fachada_waitOneSecond(JNIEnv *env, jobject obj) {

     LARGE_INTEGER ulFreq, ulTicks, ulValue, ulStartCounter, ulEAX_EDX, ulResult;

     // Calcula o nmero de clocks por segundo e armazena em ulFreq
     QueryPerformanceFrequency(&ulFreq);

     // Armazena o valor atual do contador de performance em ulTicks
     QueryPerformanceCounter(&ulTicks);

     // Calcula o intervalo de um segundo
     ulValue.QuadPart = ulTicks.QuadPart + ulFreq.QuadPart;

     // Cdigo em assembly:
     // L o time stamp counter, retorno em EAX e EDX
     // Carrega os 32 bits mais altos em ulEAX_EDX.HighPart
     // Carrega os 32 bits mais baixos em ulEAX_EDX.LowPart
     _asm {
        rdtsc
        mov ulEAX_EDX.LowPart, EAX
        mov ulEAX_EDX.HighPart, EDX
     }

     // Prepara pra fazer um loop forando o processador a executar X clocks, que demoraram 1 segundo no total
     ulStartCounter.QuadPart = ulEAX_EDX.QuadPart;

     // Executa o nmero de instrues necessrias para demorar 1 segundo
     do {
        QueryPerformanceCounter(&ulTicks);
     }  while (ulTicks.QuadPart <= ulValue.QuadPart);

     return;
}

JNIEXPORT jint JNICALL
Java_remote_Fachada_getTime(JNIEnv *env, jobject obj, jint mi, jint se) {
   jint result;
   int min = mi;
   int segs1 = se;
   int segs2 = min*60;
   _asm {
     mov eax, segs2
     mov ebx, segs1
     add eax, ebx
     mov result, eax
   }
   return result;
}
