/**
 *  Title: Controlador de Microondas
 *  Description: Projeto da disciplina Interface Hardware Software
 *  Copyright: Copyright (c) 2004. All rigths reserved to CIn - UFPE
 * Company: CIn - UFPE</p>
 * @author VBA
 * @version 2.0
 */

package remote;

import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class MicroondasGUI extends JFrame {
  private static Fachada face;
  private Icon back;
  private static int minutos;
  private static int segundos;
  private JLabel labelMicroondas = new JLabel();
  private static Label labelTempo = new Label();

  public MicroondasGUI() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.face = new Fachada();
    this.back = new ImageIcon("./src/microondas.jpg");
    this.setTitle("Controlador de Microondas");
    this.setVisible(true);
    this.getContentPane().setLayout(null);
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setSize(new Dimension(655, 440));
    labelMicroondas.setIcon(back);
    labelMicroondas.setBounds(new Rectangle(2, 2, 647, 407));
    labelMicroondas.addMouseListener(new MicroondasGUI_labelMicroondas_mouseAdapter(this));
    labelTempo.setAlignment(Label.CENTER);
    labelTempo.setBackground(Color.black);
    labelTempo.setFont(new java.awt.Font("SansSerif", 0, 32));
    labelTempo.setForeground(Color.white);
    labelTempo.setText("00:00");
    labelTempo.setBounds(new Rectangle(514, 76, 105, 50));
    this.getContentPane().add(labelMicroondas, null);
    this.getContentPane().add(labelTempo, null);
    printClock();
    minutos=0;
    segundos=0;
  }

  public static void printClock() {
    Date d = new Date();
    String min="";
    String seg="";
    if (d.getHours()-10<0) {
      min="0"+d.getHours();
    } else {
      min=""+d.getHours();
    }
    if (d.getMinutes()-10<0) {
      seg="0"+d.getMinutes();
    } else {
      seg=""+d.getMinutes();
    }
    labelTempo.setText(min+":"+seg);
   }

  public static void main(String argv[]) {
    MicroondasGUI gui = new MicroondasGUI();
    gui.setVisible(true);
  }

  void labelMicroondas_mousePressed(MouseEvent e) {

    int x = e.getX();
    int y = e.getY();
    if (x>=495 && x<=551 && y>=148 && y<=180) {
      this.incMin();
    } else {
      if (x>=563 && x<=626 && y>=148 && y<=180) {
	    this.incSeg();
      } else {
      	if (x>=566 && x<=622 && y>=359 && y<=391) {
      		this.cancelTime();
      	} else {
			if (x>=497 && x<=553 && y>=359 && y<=391) {
				this.runTime();
			}
      	}
      }
    }
  }

  public static void cancelTime() {
     segundos=0;
     minutos=0;
     printClock();
  }

  public static void incSeg() {
     if (segundos==50) {
       minutos++;
       segundos=0;
     } else {
       segundos+=10;
     }
     showTime();
  }

  public static void incMin() {
     if (minutos==99) {
       minutos=0;
     } else {
       minutos++;
     }
     showTime();
  }

  public static void runTime() {
  	int tempo = face.getTime(minutos, segundos);
	for (int i = 0; i <tempo; i++) {
		face.waitOneSecond();
		if (segundos!=0) {
			segundos--;
		} else {
			if (minutos!=0) {
			    minutos--;
			    segundos=59;
            }
		}
		showTime();
	}
	showEnd();
  }

  public static void showEnd() {
    labelTempo.setText("FIM");
    face.waitOneSecond();
    labelTempo.setText("");
    face.waitOneSecond();
    labelTempo.setText("FIM");
    face.waitOneSecond();
    printClock();
  }

  public void showPause() {
    labelTempo.setText("PAUSE");
  }

  public static void showTime() {
      String min="";
      String seg="";
      if (minutos-10<0) {
        min="0"+minutos;
      } else {
        min=""+minutos;
      }
      if (segundos-10<0) {
        seg="0"+segundos;
      } else {
        seg=""+segundos;
      }
      labelTempo.setText(min+":"+seg);
  }
}

class MicroondasGUI_labelMicroondas_mouseAdapter extends java.awt.event.MouseAdapter {
  MicroondasGUI adaptee;

  MicroondasGUI_labelMicroondas_mouseAdapter(MicroondasGUI adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.labelMicroondas_mousePressed(e);
  }
}
